//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "_GClass"
#pragma link "AbNumEdit"
#pragma link "AbPrtTrd"
#pragma link "AbTrend"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // draws 2 trends on a "Portrait" paper (A4-size) }
  if (PrintDialog1->Execute()) {
    Printer()->Title = AbPrintTrend1->Name + " - " + AbPrintTrend1->Trend->Caption;
    Printer()->Orientation = poPortrait;
    Printer()->BeginDoc();
    AbPrintTrend1->ExPrintTrend(150,100);
    // set trend to a trend on another form
    AbPrintTrend1->Trend = Form2->AbTrend1;
    AbPrintTrend1->ExPrintTrend(150,1500);
    AbPrintTrend1->Trend = AbTrend1;
    // set preview back to trend 1
    Printer()->EndDoc();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  // draws a trend on a "Landscape" paper (A4-size)
  if (PrintDialog1->Execute()) {
    Printer()->Orientation = poLandscape;
    AbPrintTrend2->PrintTrend(10,50);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  // draws a trend on a bitmap, save to file
  Graphics::TBitmap *Bmp;
  try {
    // create a bitmap
    Bmp = new Graphics::TBitmap();

    // sets Bmp size and draws the trend
   if (RadioButton1->Checked)
     AbPrintTrend1->DrawTrendBmp(Bmp);
   else
     AbPrintTrend2->DrawTrendBmp(Bmp);

   // save to file
   SaveDialog1->InitialDir = ExtractFilePath(Application->ExeName);
   SaveDialog1->DefaultExt = GraphicExtension(__classid(Graphics::TBitmap));
   SaveDialog1->FileName = "Test.bmp";
   if (SaveDialog1->Execute())
     Bmp->SaveToFile(SaveDialog1->FileName);
  }
  __finally {
    Bmp->Free();
  }
}
//---------------------------------------------------------------------------

/*

*/
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  AbTrend1->LoadFromFile("test.trd");
  SpinEdit1->Value = AbPrintTrend2->PreviewZoom * 100;
  SpinEdit2->MaxValue = AbTrend1->RecordInfo->TotalRecords;
  SpinEdit3->MaxValue = AbTrend1->RecordInfo->TotalRecords;
  SpinEdit2->Value = 78;
  SpinEdit3->Value = 477;
  SpinEdit2Change(this);
  SpinEdit3Change(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  if (CheckBox1->Checked) {
    AbPrintTrend1->Options << ptCaption, ptLegend, ptColor, ptVerticalScale;
    AbPrintTrend2->Options << ptCaption, ptLegend, ptColor, ptVerticalScale;
  } else {
    AbPrintTrend1->Options << ptCaption, ptLegend, ptVerticalScale;
    AbPrintTrend2->Options << ptCaption, ptLegend, ptVerticalScale;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpinEdit1Change(TObject *Sender)
{
  if (SpinEdit1->Value >= 10)
    if (RadioButton1->Checked)
      AbPrintTrend1->PreviewZoom = SpinEdit1->Value / 100;
    else
      AbPrintTrend2->PreviewZoom = SpinEdit1->Value / 100;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpinEdit3Change(TObject *Sender)
{
  TDateTime t;
  SpinEdit2->MaxValue = SpinEdit3->Value;
  AbTrend1->ReadRecTime(SpinEdit3->Value,t);
  Label6->Caption = DateTimeToStr(t);
  AbPrintTrend1->RecTo = SpinEdit3->Value;
  AbPrintTrend2->RecTo = SpinEdit3->Value;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpinEdit2Change(TObject *Sender)
{
  TDateTime t;
  SpinEdit3->MinValue = SpinEdit2->Value;
  AbTrend1->ReadRecTime(SpinEdit2->Value,t);
  Label5->Caption = DateTimeToStr(t);
  AbPrintTrend1->RecFrom = SpinEdit2->Value;
  AbPrintTrend2->RecFrom = SpinEdit2->Value;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
   AbPrintTrend2->PreviewPaintBox = 0;
   AbPrintTrend1->PreviewPaintBox = PaintBox1;
   SpinEdit1->Value = AbPrintTrend1->PreviewZoom * 100;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
   AbPrintTrend1->PreviewPaintBox = 0;
   AbPrintTrend2->PreviewPaintBox = PaintBox1;
   SpinEdit1->Value = AbPrintTrend2->PreviewZoom * 100;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AbPrintTrend2BeforeEndDoc(TObject *Sender)
{
  TRect r;
  r = Printer()->Canvas->ClipRect;
  Printer()->Canvas->Pen->Width = 3;
  Printer()->Canvas->Pen->Color = clBlack;
  Printer()->Canvas->Brush->Style = bsClear;
  Printer()->Canvas->Rectangle(r.Left, r.Top, r.Right, r.Bottom);
}
//---------------------------------------------------------------------------
