unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  _GClass, AbTrend, StdCtrls;

type
  TForm1 = class(TForm)
    AbTrend1: TAbTrend;
    SaveDigitButton: TButton;
    Memo1: TMemo;
    SaveValueButton: TButton;
    procedure AbTrend1RecNoChanged(Sender: TObject);
    procedure SaveDigitButtonClick(Sender: TObject);
    procedure SaveValueButtonClick(Sender: TObject);
    procedure AbTrend1Interval(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  StartTime : TDateTime;

implementation

{$R *.DFM}

procedure TForm1.AbTrend1RecNoChanged(Sender: TObject);
begin
  // "OnRecNoChanged" occours after new record added
  // aRecord ist eine "Pointer-Var" und zeigt auf den letzten bearbeiteten
  // record

  if AbTrend1.aRecord = nil then exit;

  // Startzeit vom ersten record bernehmen
  if (AbTrend1.RecordList.Count=1) then begin
    StartTime := AbTrend1.aRecord.Time;
    StartTime := StartTime - Date;   // Datum entfernen,.... sonst wird eine
                                     // Separator-Line am ersten Datensatz gezeichnet !
  end;

  // Record Zeit ndern,.... aktuelle Zeit - StartTime

  AbTrend1.aRecord.Time := AbTrend1.aRecord.Time - StartTime;

end;



procedure TForm1.SaveDigitButtonClick(Sender: TObject);
var
  n, nn       : Integer;
  oldFlow     : Boolean;
  myRecord    : PSignRec;
  str         : String;
begin
  Memo1.Clear;

  oldFlow := AbTrend1.Flow;  // save Trend-Flow status,... then stop flowing
  AbTrend1.Flow := false;    // otherwise records can be deleted by "OnMaxRecords"

  // create Header
  str := 'Time';
  for nn := 1 to 8 do str := str + CHR(9) + 'Channel ' + IntToStr(nn);
  Memo1.Lines.Add(Str);

  for n := 0 to AbTrend1.RecordList.Count-1 do begin
    myRecord := AbTrend1.RecordList.Items[n];
    str := TimeToStr(myRecord.Time);
    for nn := 1 to 8 do begin
      str := str + CHR(9) + IntToStr( myRecord.Ch[nn] );
    end;
    Memo1.Lines.Add(str);
  end;
   Memo1.Lines.SaveToFile('TrendDigit.txt');
  AbTrend1.Flow := oldFlow;
end;

procedure TForm1.SaveValueButtonClick(Sender: TObject);
var
  n, nn       : Integer;
  oldFlow     : Boolean;
  myRecord    : PSignRec;
  str         : String;
begin
  Memo1.Clear;

  oldFlow := AbTrend1.Flow;
  AbTrend1.Flow := false;

  // create Header
  str := 'Time';
  for nn := 1 to 8 do str := str + CHR(9) + 'Channel ' + IntToStr(nn);
  Memo1.Lines.Add(Str);

  for n := 0 to AbTrend1.RecordList.Count-1 do begin
    myRecord := AbTrend1.RecordList.Items[n];
    str := TimeToStr(myRecord.Time);
    for nn := 1 to 8 do begin
       // change signal "Digit" to "Value"
       str := str + CHR(9) + FormatFloat('#0.00', AbTrend1.DigitToValue(nn, myRecord.Ch[nn]) );
    end;
    Memo1.Lines.Add(str);
  end;
  Memo1.Lines.SaveToFile('TrendValue.txt');
  AbTrend1.Flow := oldFlow;
end;

procedure TForm1.AbTrend1Interval(Sender: TObject);
var
  n : integer;
begin
  // youst create some values
  for n := 1 to 8 do begin
    if AbTrend1.FChannel[n].Digit < AbTrend1.FChannel[n].DigitalTo then
      AbTrend1.FChannel[n].Digit := AbTrend1.FChannel[n].Digit + n
    else AbTrend1.FChannel[n].Digit := AbTrend1.FChannel[n].DigitalFrom ;
  end;
end;

end.
